using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductGalleries;
namespace CMSMicroservice.Protobuf.Validator.ProductGalleries;

public class GetAllProductGalleriesByFilterRequestValidator : AbstractValidator<GetAllProductGalleriesByFilterRequest>
{
    public GetAllProductGalleriesByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllProductGalleriesByFilterRequest>.CreateWithOptions((GetAllProductGalleriesByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
